function varargout = ROTHKOviewer(varargin)
% ROTHKOVIEWER M-file for ROTHKOviewer.fig
%      ROTHKOVIEWER, by itself, creates a new ROTHKOVIEWER or raises the existing
%      singleton*.
%
%      H = ROTHKOVIEWER returns the handle to a new ROTHKOVIEWER or the handle to
%      the existing singleton*.
%
%      ROTHKOVIEWER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ROTHKOVIEWER.M with the given input arguments.
%
%      ROTHKOVIEWER('Property','Value',...) creates a new ROTHKOVIEWER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ROTHKOviewer_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ROTHKOviewer_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ROTHKOviewer

% Last Modified by GUIDE v2.5 03-Sep-2008 01:43:49

% MH 2006/7

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ROTHKOviewer_OpeningFcn, ...
                   'gui_OutputFcn',  @ROTHKOviewer_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ROTHKOviewer is made visible.
function ROTHKOviewer_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ROTHKOviewer (see VARARGIN)

% Choose default command line output for ROTHKOviewer
handles.output = hObject;

handles.ROTHKO.inputdata = varargin{1};
if size(varargin,2)>1
    inputStruct = struct(varargin{2:end});
else
    inputStruct = struct;
end

if isfield(inputStruct,'firstBinMicrometer')
    handles.ROTHKO.firstBinMicrometer = inputStruct.firstBinMicrometer;
else
    handles.ROTHKO.firstBinMicrometer = 0;
end
if isfield(inputStruct,'binsize')
    handles.ROTHKO.binsize = inputStruct.binsize;
else
    handles.ROTHKO.binsize = 50;
end
if isfield(inputStruct,'profileInterpolationFactor')
    handles.ROTHKO.profileInterpolationFactor = inputStruct.profileInterpolationFactor;
else
    handles.ROTHKO.profileInterpolationFactor = 10;
end
if isfield(inputStruct,'displayWidth')
    handles.ROTHKO.displayWidth = inputStruct.displayWidth;
else
    handles.ROTHKO.displayWidth = 5;
end
if isfield(inputStruct,'traceViewOffset')
    handles.ROTHKO.traceViewOffset = inputStruct.traceViewOffset;
else
    handles.ROTHKO.traceViewOffset = 0;
end
if isfield(inputStruct,'traceViewAdditionalScale')
    handles.ROTHKO.traceViewAdditionalScale = inputStruct.traceViewAdditionalScale;
else
    handles.ROTHKO.traceViewAdditionalScale = 1;
end
if isfield(inputStruct,'yAxisLimits')
    handles.ROTHKO.yAxisLimits = inputStruct.yAxisLimits;
else
    handles.ROTHKO.yAxisLimits = [0 2000];
end
if isfield(inputStruct,'xAxisLimits')
    handles.ROTHKO.xAxisLimits = inputStruct.xAxisLimits;
else
    handles.ROTHKO.xAxisLimits = [0 5];
end
if isfield(inputStruct,'cAxisLimits')
    handles.ROTHKO.cAxisLimits = inputStruct.cAxisLimits;
else
    handles.ROTHKO.cAxisLimits = [0 500];
end
if isfield(inputStruct,'labelStr')
    handles.ROTHKO.labelStr = inputStruct.labelStr;
else
    handles.ROTHKO.labelStr = 'ROTHKOdata';
end
if isfield(inputStruct,'sourceLabelStr')
    handles.ROTHKO.sourceLabelStr = inputStruct.sourceLabelStr;
else
    handles.ROTHKO.sourceLabelStr = '';
end
if isfield(inputStruct,'normalizationFactor')
    handles.ROTHKO.normalizationFactor = inputStruct.normalizationFactor;
else
    handles.ROTHKO.normalizationFactor = 1;
end
if isfield(inputStruct,'filterSize')
    handles.ROTHKO.filterSize = inputStruct.filterSize;
else
    handles.ROTHKO.filterSize = -1;     %default
end
if isfield(inputStruct,'errorBars')
    handles.ROTHKO.errorBars = inputStruct.errorBars;
else
    handles.ROTHKO.errorBars = [];     %default
end

set(handles.edit9,'String','[]');

guidata(hObject, handles);

ROTHKO_updateTextfieldsBySettings(hObject);

ROTHKO_updatePlot(hObject);
   
    


% UIWAIT makes ROTHKOviewer wait for user response (see UIRESUME)
% uiwait(handles.figure1);


function ROTHKO_updateTextfieldsBySettings(hObject)

    handles = guidata(hObject);
    
    %set(handles.edit1,'String',num2str(handles.ROTHKO.firstBinMicrometer));
    %set(handles.edit1,'String',num2str(handles.ROTHKO.binsize));
    set(handles.edit3,'String',num2str(handles.ROTHKO.profileInterpolationFactor));
    %set(handles.edit1,'String',num2str(handles.ROTHKO.displayWidth));
    %set(handles.edit1,'String',num2str(handles.ROTHKO.traceViewAdditionalScale));
    set(handles.edit2,'String',num2str(handles.ROTHKO.normalizationFactor));
    set(handles.edit8,'String',num2str(handles.ROTHKO.filterSize));
    set(handles.edit5,'String',sprintf('[%.3f %.3f]',handles.ROTHKO.xAxisLimits(1),handles.ROTHKO.xAxisLimits(2))); %alternatively: sprintf('[%f %f]'...) => formats data with all numbers
    set(handles.edit4,'String',sprintf('[%.0f %.0f]',handles.ROTHKO.yAxisLimits(1),handles.ROTHKO.yAxisLimits(2)));
    set(handles.edit7,'String',sprintf('[%.3f %.3f]',handles.ROTHKO.cAxisLimits(1),handles.ROTHKO.cAxisLimits(2)));
    
    set(handles.text7,'String',handles.ROTHKO.labelStr);
    

function ROTHKO_updateSettingsByTextfields(hObject)

    handles = guidata(hObject);
    
    %handles.ROTHKO.firstBinMicrometer = get(str2num(handles.edit1,'String'));
    %handles.ROTHKO.binsize = get(str2num(handles.edit1,'String'));
    %handles.ROTHKO.profileInterpolationFactor = get(str2num(handles.edit1,'String'));
    %handles.ROTHKO.displayWidth = get(str2num(handles.edit1,'String'));
    handles.ROTHKO.profileInterpolationFactor = str2num(get(handles.edit3,'String'));
    handles.ROTHKO.yAxisLimits = str2num(get(handles.edit4,'String'));
    handles.ROTHKO.xAxisLimits = str2num(get(handles.edit5,'String'));
    handles.ROTHKO.cAxisLimits = str2num(get(handles.edit7,'String'));
    handles.ROTHKO.filterSize = str2num(get(handles.edit8,'String'));
    handles.ROTHKO.normalizationFactor = str2num(get(handles.edit2,'String'));
    handles.ROTHKO.labelStr = get(handles.text7,'String');
    guidata(hObject,handles);


function ROTHKO_updatePlot(hObject)

    ROTHKO_updateSettingsByTextfields(hObject);
    handles = guidata(hObject);
   
    mh_showGrayGradient_onPanel(handles.ROTHKO.inputdata,...
            handles.ROTHKO.firstBinMicrometer,...   
            handles.ROTHKO.binsize,... 
            handles.ROTHKO.profileInterpolationFactor,...  
            handles.ROTHKO.normalizationFactor,...
            handles.ROTHKO.displayWidth,... 
            handles.ROTHKO.traceViewOffset,...
            handles.ROTHKO.traceViewAdditionalScale,...              
            handles.ROTHKO.yAxisLimits,...  
            handles.ROTHKO.xAxisLimits,... 
            handles.ROTHKO.cAxisLimits,...
            handles.axes1,...
            handles.ROTHKO.filterSize,...
            0,...
            '',...
            '',...
            [],...
            handles.ROTHKO.errorBars);


% --- Outputs from this function are returned to the command line.
function varargout = ROTHKOviewer_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double


% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ROTHKO_updatePlot(hObject)



function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double


% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

rothko_exportFigure = figure;
set(rothko_exportFigure,'NumberTitle','off','Name','ROTHKOviewer Export figure for saving/printing');
rothko_exportAxes = subplot(1,2,1);
rothko_exportAxesInfo = subplot(1,2,2);
rothko_isolevels = str2num(get(handles.edit9,'String'));
mh_showGrayGradient_onPanel(handles.ROTHKO.inputdata,...
            handles.ROTHKO.firstBinMicrometer,...   
            handles.ROTHKO.binsize,... 
            handles.ROTHKO.profileInterpolationFactor,...  
            handles.ROTHKO.normalizationFactor,...
            handles.ROTHKO.displayWidth,... 
            handles.ROTHKO.traceViewOffset,...
            handles.ROTHKO.traceViewAdditionalScale,...              
            handles.ROTHKO.yAxisLimits,...  
            handles.ROTHKO.xAxisLimits,... 
            handles.ROTHKO.cAxisLimits,...
            rothko_exportAxes,...
            handles.ROTHKO.filterSize,...
            rothko_exportAxesInfo,...
            handles.ROTHKO.labelStr,...
            handles.ROTHKO.sourceLabelStr,...
            rothko_isolevels,...
            handles.ROTHKO.errorBars);
        
% [filename,pathname] = uiputfile('*.pdf');
% 
% if filename~=0
%     saveas(rothko_exportFigure,sprintf('%s%s',pathname,filename),'pdf');
% end
        
        



function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit8 as text
%        str2double(get(hObject,'String')) returns contents of edit8 as a double


% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function edit9_Callback(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit9 as text
%        str2double(get(hObject,'String')) returns contents of edit9 as a double


% --- Executes during object creation, after setting all properties.
function edit9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


